These are the messages that will be spoken to the user as the tool is running.
For some tools, this is auto-filled based on special fields like tool.destinations. For others like the function tool, these can be custom configured.
ToolMessageStart
ToolMessageComplete
ToolMessageFailed
ToolMessageDelayed
Show child attributes
method
enum<string>
Available options:
POST,
GET
timeoutSeconds
number
This is the timeout in seconds for the request. Defaults to 20 seconds.
@default 20
Required range: 1 <= x <= 300
Example:
20
function
object
This is the function definition of the tool.
For endCall, transferCall, and dtmf tools, this is auto-filled based on tool-specific fields like tool.destinations. But, even in those cases, you can provide a custom function definition for advanced use cases.
An example of an advanced use case is if you want to customize the message that's spoken for endCall tool. You can specify a function where it returns an argument "reason". Then, in messages array, you can have many "request-complete" messages. One of these messages will be triggered if the messages[].conditions matches the "reason" argument.
Show child attributes
name
string
This is the name of the tool. This will be passed to the model.
Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 40.
Maximum string length: 40
Pattern: /^[a-zA-Z0-9_-]{1,40}$/
description
string
This is the description of the tool. This will be passed to the model.
Maximum string length: 1000
url
string
This is where the request will be sent.
body
object
This is the body of the request.
Show child attributes
headers
object
These are the headers to send in the request.
Show child attributes
backoffPlan
object
This is the backoff plan if the request fails. Defaults to undefined (the request will not be retried).
@default undefined (the request will not be retried)
Show child attributes
variableExtractionPlan
object
This is the plan to extract variables from the tool's response. These will be accessible during the call and stored in call.artifact.variableValues after the call.
Usage:
Use aliases to extract variables from the tool's response body. (Most common case)
$ is a shorthand for the tool's response body. $[0] is the first item in the array. $[n] is the nth item in the array. Note, $ is available regardless of the response body type (both object and array).
Use aliases to extract variables from the tool's response headers.
tool.response is made available to the liquid template. Particularly, both tool.response.headers and tool.response.body are available. Note, tool.response is available regardless of the response body type (both object and array).
Use schema to extract a large portion of the tool's response body.
4.1. If you hit example.com and it returns {"name": "John", "age": 30}, then you can specify the schema as:
This will be extracted as {{ zipCodes }}. To access the array items, you can use {{ zipCodes[0] }} and {{ zipCodes[1] }}.
4.5. If you hit example.com and it returns [{"name": "John", "age": 30, "zipCodes": ["94123", "94124"]}, {"name": "Jane", "age": 25, "zipCodes": ["94125", "94126"]}], then you can specify the schema as:
This will be extracted as {{ people }}. To access the array items, you can use {{ people[n].name }}, {{ people[n].age }}, {{ people[n].zipCodes }}, {{ people[n].zipCodes[0] }} and {{ people[n].zipCodes[1] }}.
Note: Both aliases and schema can be used together.
Show child attributes
Response
200 - application/json
ApiRequestTool
DtmfTool
EndCallTool
FunctionTool
GhlTool
MakeTool
TransferCallTool
OutputTool
BashTool
ComputerTool
TextEditorTool
QueryTool
GoogleCalendarCreateEventTool
GoogleSheetsRowAppendTool
GoogleCalendarCheckAvailabilityTool
SlackSendMessageTool
SmsSendTool
McpTool
GoHighLevelCalendarAvailabilityTool
GoHighLevelCalendarEventCreateTool
GoHighLevelContactCreateTool
GoHighLevelContactGetTool
type
enum<string>
required
The type of tool. "apiRequest" for API request tool.
Available options:
apiRequest
method
enum<string>
required
Available options:
POST,
GET
id
string
required
This is the unique identifier for the tool.
orgId
string
required
This is the unique identifier for the organization that this tool belongs to.
createdAt
string<date-time>
required
This is the ISO 8601 date-time string of when the tool was created.
updatedAt
string<date-time>
required
This is the ISO 8601 date-time string of when the tool was last updated.
These are the messages that will be spoken to the user as the tool is running.
For some tools, this is auto-filled based on special fields like tool.destinations. For others like the function tool, these can be custom configured.
ToolMessageStart
ToolMessageComplete
ToolMessageFailed
ToolMessageDelayed
Show child attributes
timeoutSeconds
number
This is the timeout in seconds for the request. Defaults to 20 seconds.
@default 20
Required range: 1 <= x <= 300
Example:
20
function
object
This is the function definition of the tool.
For endCall, transferCall, and dtmf tools, this is auto-filled based on tool-specific fields like tool.destinations. But, even in those cases, you can provide a custom function definition for advanced use cases.
An example of an advanced use case is if you want to customize the message that's spoken for endCall tool. You can specify a function where it returns an argument "reason". Then, in messages array, you can have many "request-complete" messages. One of these messages will be triggered if the messages[].conditions matches the "reason" argument.
Show child attributes
name
string
This is the name of the tool. This will be passed to the model.
Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 40.
Maximum string length: 40
Pattern: /^[a-zA-Z0-9_-]{1,40}$/
description
string
This is the description of the tool. This will be passed to the model.
Maximum string length: 1000
body
object
This is the body of the request.
Show child attributes
headers
object
These are the headers to send in the request.
Show child attributes
backoffPlan
object
This is the backoff plan if the request fails. Defaults to undefined (the request will not be retried).
@default undefined (the request will not be retried)
Show child attributes
variableExtractionPlan
object
This is the plan to extract variables from the tool's response. These will be accessible during the call and stored in call.artifact.variableValues after the call.
Usage:
Use aliases to extract variables from the tool's response body. (Most common case)
$ is a shorthand for the tool's response body. $[0] is the first item in the array. $[n] is the nth item in the array. Note, $ is available regardless of the response body type (both object and array).
Use aliases to extract variables from the tool's response headers.
tool.response is made available to the liquid template. Particularly, both tool.response.headers and tool.response.body are available. Note, tool.response is available regardless of the response body type (both object and array).
Use schema to extract a large portion of the tool's response body.
4.1. If you hit example.com and it returns {"name": "John", "age": 30}, then you can specify the schema as:
This will be extracted as {{ zipCodes }}. To access the array items, you can use {{ zipCodes[0] }} and {{ zipCodes[1] }}.
4.5. If you hit example.com and it returns [{"name": "John", "age": 30, "zipCodes": ["94123", "94124"]}, {"name": "Jane", "age": 25, "zipCodes": ["94125", "94126"]}], then you can specify the schema as:
This will be extracted as {{ people }}. To access the array items, you can use {{ people[n].name }}, {{ people[n].age }}, {{ people[n].zipCodes }}, {{ people[n].zipCodes[0] }} and {{ people[n].zipCodes[1] }}.
Note: Both aliases and schema can be used together.
Show child attributes
{"docsConfig":{"$schema":"https://mintlify.com/docs.json","theme":"mint","name":"Cozmox-AI Nebula SDK","colors":{"primary":"#FF5911","light":"#FF5911","dark":"#c44b09"},"favicon":"/logo/favicon.png","logo":{"light":"https://mintlify.s3.us-west-1.amazonaws.com/czmx/logo/logo_light.svg","dark":"https://mintlify.s3.us-west-1.amazonaws.com/czmx/logo/logo_dark.svg"},"navbar":{"links":[{"label":"Support","href":"mailto:development@cozmox.ai"}],"primary":{"type":"button","label":"Dashboard","href":"https://cozmox.ai"}},"footer":{"socials":{"x":"https://x.com/cozmoxai","linkedin":"https://www.linkedin.com/company/cozmox-ai/"}},"navigation":{"pages":[]}},"deployment":{"deploymentMetadataValue":{"subdomain":"czmx","hasAudioNarration":false,"actualSubdomain":"czmx","customDomains":["docs.cozmox.cloud"],"gitSource":{"type":"github","owner":"zywa-co","repo":"sdk-docs","deployBranch":"main","contentDirectory":"","isPrivate":false,"mountPath":"","label":""},"entitlements":{},"buildId":"6ae9248dc5f2fcf249014baf:success","clientVersion":"0.0.4160","searchFilterCounts":[{"language":"default","tag":"API Reference","count":120},{"language":"default","tag":"Assistants","count":5},{"language":"default","tag":"Calls","count":5},{"language":"default","tag":"Campaigns","count":5},{"language":"default","tag":"Chats","count":5},{"language":"default","tag":"Files","count":5},{"language":"default","tag":"Knowledge Base","count":5},{"language":"default","tag":"Phone Numbers","count":5},{"language":"default","tag":"Sessions","count":5},{"language":"default","tag":"Tools","count":5}]},"assistantConfig":{},"basePath":"","hasChatPermissions":false,"hasWebMcpPermissions":false,"toggles":[{"name":"kill-isr","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"custom-rbac-roles","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-mintlify-slack","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-integrations-settings","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"rbac-expansion","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-pr-grouping","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"custom-prefix","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"analytics-v7","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"user-flows-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"no-publish-flow","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-onboarding","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving-live","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"stripTemperatureMiddleware","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"support-platform-pylon-zendesk","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"instant-rollback","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications-server","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-fable","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fixed-ai-action-pricing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automation-resolve-merge-conflict","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"scoped-publishing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"mintql","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"page-level-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-version-history-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-page-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"full-page-search","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workspace-projects","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"assistant-v5","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fork-pr-previews","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"revalidation-jwt","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-sso-scim","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"hobby-abuse-scan","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"dashboard-inbox","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-signup","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"turbopuffer-dual-write","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-enabled","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"approve-review-flow","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-metadata","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"sso-setup-deadline-banner","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"turbopuffer-serve","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"live-agents","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"llms-txt-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false}],"googleFontsInlined":false},"customCss":[],"page":{"pagePath":"api-reference/tools/update-tool","slug":"/api-reference/tools/update-tool","pageMetadata":{"openapi":"patch /tool/{id}","title":"Update Tool","description":null,"href":"/api-reference/tools/update-tool"},"pageType":"default","mdx":{"mdxSource":{"compiledSource":"\"use strict\";const{Fragment:_Fragment,jsx:_jsx}=arguments[0];const{useMDXComponents:_provideComponents}=arguments[0];function _createMdxContent(props){return _jsx(_Fragment,{})}function MDXContent(props={}){const{wrapper:MDXLayout}={..._provideComponents(),...props.components};return MDXLayout?_jsx(MDXLayout,{...props,children:_jsx(_createMdxContent,{...props})}):_createMdxContent(props)}return{default:MDXContent}","frontmatter":{},"scope":{"config":{},"pageMetadata":{"openapi":"patch /tool/{id}","title":"Update Tool","description":null,"href":"/api-reference/tools/update-tool"}}},"mdxSourceWithNoJs":null},"mdxExtracts":{"tableOfContents":[],"codeExamples":{}},"jsLinks":[],"openApiReferenceData":{"operation":{"operationId":"ToolController_update","summary":"Update Tool","parameters":["8612b823-1c1c-4865-b84e-99a40d2103dd"],"requestBody":"3b1dc3ee-01c5-48d7-903c-7f289d7d40de","responses":{"200":"a6c163ab-b871-448c-a0b3-83c4013a167e"},"tags":["Tools"],"security":["427368f3-06de-426a-abe2-75fda5295409"],"method":"patch","type":"path","servers":["b5b8326a-680d-4e65-bd4d-46e31c9c1334","1698761f-fe56-43c1-839e-05ab7d829049"],"path":"/tool/{id}","baseUrlOptions":["https://api.cozmox.ai","https://api.cozmox.ai"],"title":"Update Tool","description":"","codeSamples":[],"requiredOnlyExamples":false,"requestExampleType":"generated","responseExampleType":"generated"},"dependencies":{"parameters":{"8612b823-1c1c-4865-b84e-99a40d2103dd":{"name":"id","required":true,"in":"path","schema":{"type":"string","isRequired":true,"uniqueKey":"","typeLabel":"string"}}},"requestBody":{"required":true,"content":{"application/json":{"schema":{"oneOf":[{"type":"object","title":"ApiRequestTool","properties":{"messages":{"type":"array","description":"These are the messages that will be spoken to the user as the tool is running.\n\nFor some tools, this is auto-filled based on special fields like `tool.destinations`. For others like the function tool, these can be custom configured.","items":{"oneOf":[{"type":"object","title":"ToolMessageStart","required":["type"],"properties":{"type":{"type":"string","enum":["request-start"],"description":"This message is triggered when the tool call starts.\n\nThis message is never triggered for async tools.\n\nIf this message is not provided, one of the default filler messages \"Hold on a sec\", \"One moment\", \"Just a sec\", \"Give me a moment\" or \"This'll just take a sec\" will be used.","isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.0.type","typeLabel":"enum\u003cstring>"},"contents":{"type":"array","description":"This is an alternative to the `content` property. It allows to specify variants of the same content, one per language.\n\nUsage:\n- If your assistants are multilingual, you can provide content for each language.\n- If you don't provide content for a language, the first item in the array will be automatically translated to the active language at that moment.\n\nThis will override the `content` property.","items":{"type":"object","title":"Text","required":["type","text","language"],"properties":{"type":{"type":"string","enum":["text"],"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.0.contents.items.[INDEX].type","typeLabel":"enum\u003cstring>"},"text":{"type":"string","isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.0.contents.items.[INDEX].text","typeLabel":"string"},"language":{"type":"string","enum":["aa","ab","ae","af","ak","am","an","ar","as","av","ay","az","ba","be","bg","bh","bi","bm","bn","bo","br","bs","ca","ce","ch","co","cr","cs","cu","cv","cy","da","de","dv","dz","ee","el","en","eo","es","et","eu","fa","ff","fi","fj","fo","fr","fy","ga","gd","gl","gn","gu","gv","ha","he","hi","ho","hr","ht","hu","hy","hz","ia","id","ie","ig","ii","ik","io","is","it","iu","ja","jv","ka","kg","ki","kj","kk","kl","km","kn","ko","kr","ks","ku","kv","kw","ky","la","lb","lg","li","ln","lo","lt","lu","lv","mg","mh","mi","mk","ml","mn","mr","ms","mt","my","na","nb","nd","ne","ng","nl","nn","no","nr","nv","ny","oc","oj","om","or","os","pa","pi","pl","ps","pt","qu","rm","rn","ro","ru","rw","sa","sc","sd","se","sg","si","sk","sl","sm","sn","so","sq","sr","ss","st","su","sv","sw","ta","te","tg","th","ti","tk","tl","tn","to","tr","ts","tt","tw","ty","ug","uk","ur","uz","ve","vi","vo","wa","wo","xh","yi","yue","yo","za","zh","zu"],"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.0.contents.items.[INDEX].language","typeLabel":"enum\u003cstring>"}},"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.0.contents.items.[INDEX]","typeLabel":"Text · object"},"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.0.contents","typeLabel":"Text · object[]"},"blocking":{"type":"boolean","description":"This is an optional boolean that if true, the tool call will only trigger after the message is spoken. Default is false.\n\n@default false","example":false,"default":false,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.0.blocking","typeLabel":"boolean"},"content":{"type":"string","description":"This is the content that the assistant says when this message is triggered.","maxLength":1000,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.0.content","typeLabel":"string"},"conditions":{"description":"This is an optional array of conditions that the tool call arguments must meet in order for this message to be triggered.","type":"array","items":{"type":"object","properties":{"operator":{"type":"string","description":"This is the operator you want to use to compare the parameter and value.","enum":["eq","neq","gt","gte","lt","lte"],"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.0.conditions.items.[INDEX].operator","typeLabel":"enum\u003cstring>"},"param":{"type":"string","description":"This is the name of the parameter that you want to check.","maxLength":1000,"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.0.conditions.items.[INDEX].param","typeLabel":"string"},"value":{"type":"string","description":"This is the value you want to compare against the parameter.","maxLength":1000,"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.0.conditions.items.[INDEX].value","typeLabel":"string"}},"required":["operator","param","value"],"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.0.conditions.items.[INDEX]","typeLabel":"object"},"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.0.conditions","typeLabel":"object[]"}},"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.0","typeLabel":"ToolMessageStart · object"},{"type":"object","title":"ToolMessageComplete","required":["type"],"properties":{"type":{"type":"string","description":"This message is triggered when the tool call is complete.\n\nThis message is triggered immediately without waiting for your server to respond for async tool calls.\n\nIf this message is not provided, the model will be requested to respond.\n\nIf this message is provided, only this message will be spoken and the model will not be requested to come up with a response. It's an exclusive OR.","enum":["request-complete"],"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.1.type","typeLabel":"enum\u003cstring>"},"contents":{"type":"array","description":"This is an alternative to the `content` property. It allows to specify variants of the same content, one per language.\n\nUsage:\n- If your assistants are multilingual, you can provide content for each language.\n- If you don't provide content for a language, the first item in the array will be automatically translated to the active language at that moment.\n\nThis will override the `content` property.","items":{"type":"object","title":"Text","required":["type","text","language"],"properties":{"type":{"type":"string","enum":["text"],"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.1.contents.items.[INDEX].type","typeLabel":"enum\u003cstring>"},"text":{"type":"string","isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.1.contents.items.[INDEX].text","typeLabel":"string"},"language":{"type":"string","enum":["aa","ab","ae","af","ak","am","an","ar","as","av","ay","az","ba","be","bg","bh","bi","bm","bn","bo","br","bs","ca","ce","ch","co","cr","cs","cu","cv","cy","da","de","dv","dz","ee","el","en","eo","es","et","eu","fa","ff","fi","fj","fo","fr","fy","ga","gd","gl","gn","gu","gv","ha","he","hi","ho","hr","ht","hu","hy","hz","ia","id","ie","ig","ii","ik","io","is","it","iu","ja","jv","ka","kg","ki","kj","kk","kl","km","kn","ko","kr","ks","ku","kv","kw","ky","la","lb","lg","li","ln","lo","lt","lu","lv","mg","mh","mi","mk","ml","mn","mr","ms","mt","my","na","nb","nd","ne","ng","nl","nn","no","nr","nv","ny","oc","oj","om","or","os","pa","pi","pl","ps","pt","qu","rm","rn","ro","ru","rw","sa","sc","sd","se","sg","si","sk","sl","sm","sn","so","sq","sr","ss","st","su","sv","sw","ta","te","tg","th","ti","tk","tl","tn","to","tr","ts","tt","tw","ty","ug","uk","ur","uz","ve","vi","vo","wa","wo","xh","yi","yue","yo","za","zh","zu"],"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.1.contents.items.[INDEX].language","typeLabel":"enum\u003cstring>"}},"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.1.contents.items.[INDEX]","typeLabel":"Text · object"},"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.1.contents","typeLabel":"Text · object[]"},"role":{"type":"string","description":"This is optional and defaults to \"assistant\".\n\nWhen role=assistant, `content` is said out loud.\n\nWhen role=system, `content` is passed to the model in a system message. Example:\n system: default one\n assistant:\n user:\n assistant:\n user:\n assistant:\n user:\n assistant: tool called\n tool: your server response\n \u003c--- system prompt as hint\n ---> model generates response which is spoken\nThis is useful when you want to provide a hint to the model about what to say next.","enum":["assistant","system"],"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.1.role","typeLabel":"enum\u003cstring>"},"endCallAfterSpokenEnabled":{"type":"boolean","description":"This is an optional boolean that if true, the call will end after the message is spoken. Default is false.\n\nThis is ignored if `role` is set to `system`.\n\n@default false","example":false,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.1.endCallAfterSpokenEnabled","typeLabel":"boolean"},"content":{"type":"string","description":"This is the content that the assistant says when this message is triggered.","maxLength":1000,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.1.content","typeLabel":"string"},"conditions":{"description":"This is an optional array of conditions that the tool call arguments must meet in order for this message to be triggered.","type":"array","items":{"type":"object","properties":{"operator":{"type":"string","description":"This is the operator you want to use to compare the parameter and value.","enum":["eq","neq","gt","gte","lt","lte"],"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.1.conditions.items.[INDEX].operator","typeLabel":"enum\u003cstring>"},"param":{"type":"string","description":"This is the name of the parameter that you want to check.","maxLength":1000,"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.1.conditions.items.[INDEX].param","typeLabel":"string"},"value":{"type":"string","description":"This is the value you want to compare against the parameter.","maxLength":1000,"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.1.conditions.items.[INDEX].value","typeLabel":"string"}},"required":["operator","param","value"],"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.1.conditions.items.[INDEX]","typeLabel":"object"},"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.1.conditions","typeLabel":"object[]"}},"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.1","typeLabel":"ToolMessageComplete · object"},{"type":"object","title":"ToolMessageFailed","required":["type"],"properties":{"type":{"type":"string","description":"This message is triggered when the tool call fails.\n\nThis message is never triggered for async tool calls.\n\nIf this message is not provided, the model will be requested to respond.\n\nIf this message is provided, only this message will be spoken and the model will not be requested to come up with a response. It's an exclusive OR.","enum":["request-failed"],"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.2.type","typeLabel":"enum\u003cstring>"},"contents":{"type":"array","description":"This is an alternative to the `content` property. It allows to specify variants of the same content, one per language.\n\nUsage:\n- If your assistants are multilingual, you can provide content for each language.\n- If you don't provide content for a language, the first item in the array will be automatically translated to the active language at that moment.\n\nThis will override the `content` property.","items":{"type":"object","title":"Text","required":["type","text","language"],"properties":{"type":{"type":"string","enum":["text"],"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.2.contents.items.[INDEX].type","typeLabel":"enum\u003cstring>"},"text":{"type":"string","isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.2.contents.items.[INDEX].text","typeLabel":"string"},"language":{"type":"string","enum":["aa","ab","ae","af","ak","am","an","ar","as","av","ay","az","ba","be","bg","bh","bi","bm","bn","bo","br","bs","ca","ce","ch","co","cr","cs","cu","cv","cy","da","de","dv","dz","ee","el","en","eo","es","et","eu","fa","ff","fi","fj","fo","fr","fy","ga","gd","gl","gn","gu","gv","ha","he","hi","ho","hr","ht","hu","hy","hz","ia","id","ie","ig","ii","ik","io","is","it","iu","ja","jv","ka","kg","ki","kj","kk","kl","km","kn","ko","kr","ks","ku","kv","kw","ky","la","lb","lg","li","ln","lo","lt","lu","lv","mg","mh","mi","mk","ml","mn","mr","ms","mt","my","na","nb","nd","ne","ng","nl","nn","no","nr","nv","ny","oc","oj","om","or","os","pa","pi","pl","ps","pt","qu","rm","rn","ro","ru","rw","sa","sc","sd","se","sg","si","sk","sl","sm","sn","so","sq","sr","ss","st","su","sv","sw","ta","te","tg","th","ti","tk","tl","tn","to","tr","ts","tt","tw","ty","ug","uk","ur","uz","ve","vi","vo","wa","wo","xh","yi","yue","yo","za","zh","zu"],"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.2.contents.items.[INDEX].language","typeLabel":"enum\u003cstring>"}},"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.2.contents.items.[INDEX]","typeLabel":"Text · object"},"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.2.contents","typeLabel":"Text · object[]"},"endCallAfterSpokenEnabled":{"type":"boolean","description":"This is an optional boolean that if true, the call will end after the message is spoken. Default is false.\n\n@default false","example":false,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.2.endCallAfterSpokenEnabled","typeLabel":"boolean"},"content":{"type":"string","description":"This is the content that the assistant says when this message is triggered.","maxLength":1000,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.2.content","typeLabel":"string"},"conditions":{"description":"This is an optional array of conditions that the tool call arguments must meet in order for this message to be triggered.","type":"array","items":{"type":"object","properties":{"operator":{"type":"string","description":"This is the operator you want to use to compare the parameter and value.","enum":["eq","neq","gt","gte","lt","lte"],"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.2.conditions.items.[INDEX].operator","typeLabel":"enum\u003cstring>"},"param":{"type":"string","description":"This is the name of the parameter that you want to check.","maxLength":1000,"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.2.conditions.items.[INDEX].param","typeLabel":"string"},"value":{"type":"string","description":"This is the value you want to compare against the parameter.","maxLength":1000,"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.2.conditions.items.[INDEX].value","typeLabel":"string"}},"required":["operator","param","value"],"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.2.conditions.items.[INDEX]","typeLabel":"object"},"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.2.conditions","typeLabel":"object[]"}},"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.2","typeLabel":"ToolMessageFailed · object"},{"type":"object","title":"ToolMessageDelayed","required":["type"],"properties":{"type":{"type":"string","description":"This message is triggered when the tool call is delayed.\n\nThere are the two things that can trigger this message:\n1. The user talks with the assistant while your server is processing the request. Default is \"Sorry, a few more seconds.\"\n2. The server doesn't respond within `timingMilliseconds`.\n\nThis message is never triggered for async tool calls.","enum":["request-response-delayed"],"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.3.type","typeLabel":"enum\u003cstring>"},"contents":{"type":"array","description":"This is an alternative to the `content` property. It allows to specify variants of the same content, one per language.\n\nUsage:\n- If your assistants are multilingual, you can provide content for each language.\n- If you don't provide content for a language, the first item in the array will be automatically translated to the active language at that moment.\n\nThis will override the `content` property.","items":{"type":"object","title":"Text","required":["type","text","language"],"properties":{"type":{"type":"string","enum":["text"],"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.3.contents.items.[INDEX].type","typeLabel":"enum\u003cstring>"},"text":{"type":"string","isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.3.contents.items.[INDEX].text","typeLabel":"string"},"language":{"type":"string","enum":["aa","ab","ae","af","ak","am","an","ar","as","av","ay","az","ba","be","bg","bh","bi","bm","bn","bo","br","bs","ca","ce","ch","co","cr","cs","cu","cv","cy","da","de","dv","dz","ee","el","en","eo","es","et","eu","fa","ff","fi","fj","fo","fr","fy","ga","gd","gl","gn","gu","gv","ha","he","hi","ho","hr","ht","hu","hy","hz","ia","id","ie","ig","ii","ik","io","is","it","iu","ja","jv","ka","kg","ki","kj","kk","kl","km","kn","ko","kr","ks","ku","kv","kw","ky","la","lb","lg","li","ln","lo","lt","lu","lv","mg","mh","mi","mk","ml","mn","mr","ms","mt","my","na","nb","nd","ne","ng","nl","nn","no","nr","nv","ny","oc","oj","om","or","os","pa","pi","pl","ps","pt","qu","rm","rn","ro","ru","rw","sa","sc","sd","se","sg","si","sk","sl","sm","sn","so","sq","sr","ss","st","su","sv","sw","ta","te","tg","th","ti","tk","tl","tn","to","tr","ts","tt","tw","ty","ug","uk","ur","uz","ve","vi","vo","wa","wo","xh","yi","yue","yo","za","zh","zu"],"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.3.contents.items.[INDEX].language","typeLabel":"enum\u003cstring>"}},"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.3.contents.items.[INDEX]","typeLabel":"Text · object"},"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.3.contents","typeLabel":"Text · object[]"},"timingMilliseconds":{"type":"number","minimum":100,"maximum":120000,"example":1000,"description":"The number of milliseconds to wait for the server response before saying this message.","uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.3.timingMilliseconds","typeLabel":"number"},"content":{"type":"string","description":"This is the content that the assistant says when this message is triggered.","maxLength":1000,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.3.content","typeLabel":"string"},"conditions":{"description":"This is an optional array of conditions that the tool call arguments must meet in order for this message to be triggered.","type":"array","items":{"type":"object","properties":{"operator":{"type":"string","description":"This is the operator you want to use to compare the parameter and value.","enum":["eq","neq","gt","gte","lt","lte"],"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.3.conditions.items.[INDEX].operator","typeLabel":"enum\u003cstring>"},"param":{"type":"string","description":"This is the name of the parameter that you want to check.","maxLength":1000,"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.3.conditions.items.[INDEX].param","typeLabel":"string"},"value":{"type":"string","description":"This is the value you want to compare against the parameter.","maxLength":1000,"isRequired":true,"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.3.conditions.items.[INDEX].value","typeLabel":"string"}},"required":["operator","param","value"],"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.3.conditions.items.[INDEX]","typeLabel":"object"},"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.3.conditions","typeLabel":"object[]"}},"uniqueKey":"oneOf.0.messages.items.[INDEX].oneOf.3","typeLabel":"ToolMessageDelayed · object"}],"uniqueKey":"oneOf.0.messages.items.[INDEX]","typeLabel":"ToolMessageStart · object | ToolMessageComplete · object | ToolMessageFailed · object | ToolMessageDelayed · object"},"uniqueKey":"oneOf.0.messages","typeLabel":"(ToolMessageStart · object | ToolMessageComplete · object | ToolMessageFailed · object | ToolMessageDelayed · object)[]"},"method":{"type":"string","enum":["POST","GET"],"uniqueKey":"oneOf.0.method","typeLabel":"enum\u003cstring>"},"timeoutSeconds":{"type":"number","description":"This is the timeout in seconds for the request. Defaults to 20 seconds.\n\n@default 20","minimum":1,"maximum":300,"example":20,"uniqueKey":"oneOf.0.timeoutSeconds","typeLabel":"number"},"function":{"type":"object","description":"This is the function definition of the tool.\n\nFor `endCall`, `transferCall`, and `dtmf` tools, this is auto-filled based on tool-specific fields like `tool.destinations`. But, even in those cases, you can provide a custom function definition for advanced use cases.\n\nAn example of an advanced use case is if you want to customize the message that's spoken for `endCall` tool. You can specify a function where it returns an argument \"reason\". Then, in `messages` array, you can have many \"request-complete\" messages. One of these messages will be triggered if the `messages[].conditions` matches the \"reason\" argument.","required":["name"],"properties":{"name":{"type":"string","description":"This is the the name of the function to be called.\n\nMust be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.","maxLength":64,"pattern":"/^[a-zA-Z0-9_-]{1,64}$/","isRequired":true,"uniqueKey":"oneOf.0.function.name","typeLabel":"string"},"strict":{"type":"boolean","description":"This is a boolean that controls whether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the parameters field. Only a subset of JSON Schema is supported when strict is true. Learn more about Structured Outputs in the [OpenAI guide](https://openai.com/index/introducing-structured-outputs-in-the-api/).\n\n@default false","default":false,"uniqueKey":"oneOf.0.function.strict","typeLabel":"boolean"},"description":{"type":"string","description":"This is the description of what the function does, used by the AI to choose when and how to call the function.","maxLength":1000,"uniqueKey":"oneOf.0.function.description","typeLabel":"string"},"parameters":{"type":"object","description":"These are the parameters the functions accepts, described as a JSON Schema object.\n\nSee the [OpenAI guide](https://platform.openai.com/docs/guides/function-calling) for examples, and the [JSON Schema reference](https://json-schema.org/understanding-json-schema) for documentation about the format.\n\nOmitting parameters defines a function with an empty parameter list.","required":["type","properties"],"properties":{"type":{"type":"string","description":"This must be set to 'object'. It instructs the model to return a JSON object containing the function call properties.","enum":["object"],"isRequired":true,"uniqueKey":"oneOf.0.function.parameters.type","typeLabel":"enum\u003cstring>"},"properties":{"type":"object","description":"This provides a description of the properties required by the function.\nJSON Schema can be used to specify expectations for each property.\nRefer to [this doc](https://ajv.js.org/json-schema.html#json-data-type) for a comprehensive guide on JSON Schema.","additionalProperties":{"type":"object","properties":{"type":{"type":"string","description":"This is the type of output you'd like.\n\n`string`, `number`, `integer`, `boolean` are the primitive types and should be obvious.\n\n`array` and `object` are more interesting and quite powerful. They allow you to define nested structures.\n\nFor `array`, you can define the schema of the items in the array using the `items` property.\n\nFor `object`, you can define the properties of the object using the `properties` property.","enum":["string","number","integer","boolean","array","object"],"isRequired":true,"uniqueKey":"oneOf.0.function.parameters.properties.additionalProperties.type","typeLabel":"enum\u003cstring>"},"items":{"type":"object","description":"This is required if the type is \"array\". This is the schema of the items in the array.\n\nThis is of type JsonSchema. However, Swagger doesn't support circular references.","uniqueKey":"oneOf.0.function.parameters.properties.additionalProperties.\\items","typeLabel":"object"},"properties":{"type":"object","description":"This is required if the type is \"object\". This specifies the properties of the object.\n\nThis is a map of string to JsonSchema. However, Swagger doesn't support circular references.","uniqueKey":"oneOf.0.function.parameters.properties.additionalProperties.properties","typeLabel":"object"},"description":{"type":"string","description":"This is the description to help the model understand what it needs to output.","uniqueKey":"oneOf.0.function.parameters.properties.additionalProperties.description","typeLabel":"string"},"pattern":{"type":"string","description":"This is the pattern of the string. This is a regex that will be used to validate the data in question. To use a common format, use the `format` property instead.\n\nOpenAI documentation: https://platform.openai.com/docs/guides/structured-outputs#supported-properties","uniqueKey":"oneOf.0.function.parameters.properties.additionalProperties.pattern","typeLabel":"string"},"format":{"type":"string","description":"This is the format of the string. To pass a regex, use the `pattern` property instead.\n\nOpenAI documentation: https://platform.openai.com/docs/guides/structured-outputs?api-mode=chat\u0026type-restrictions=string-restrictions","enum":["date-time","time","date","duration","email","hostname","ipv4","ipv6","uuid"],"uniqueKey":"oneOf.0.function.parameters.properties.additionalProperties.format","typeLabel":"enum\u003cstring>"},"required":{"description":"This is a list of properties that are required.\n\nThis only makes sense if the type is \"object\".","type":"array","items":{"type":"string","uniqueKey":"oneOf.0.function.parameters.properties.additionalProperties.required.items.[INDEX]","typeLabel":"string"},"uniqueKey":"oneOf.0.function.parameters.properties.additionalProperties.required","typeLabel":"string[]"},"enum":{"description":"This array specifies the allowed values that can be used to restrict the output of the model.","type":"array","items":{"type":"string","uniqueKey":"oneOf.0.function.parameters.properties.additionalProperties.enum.items.[INDEX]","typeLabel":"string"},"uniqueKey":"oneOf.0.function.parameters.properties.additionalProperties.enum","typeLabel":"string[]"},"title":{"type":"string","description":"This is the title of the schema.","uniqueKey":"oneOf.0.function.parameters.properties.additionalProperties.title","typeLabel":"string"}},"required":["type"],"uniqueKey":"oneOf.0.function.parameters.properties.additionalProperties","typeLabel":"object"},"isRequired":true,"uniqueKey":"oneOf.0.function.parameters.properties","typeLabel":"object"},"required":{"description":"This specifies the properties that are required by the function.","type":"array","items":{"type":"string","uniqueKey":"oneOf.0.function.parameters.required.items.[INDEX]","typeLabel":"string"},"uniqueKey":"oneOf.0.function.parameters.required","typeLabel":"string[]"}},"uniqueKey":"oneOf.0.function.parameters","typeLabel":"object"}},"uniqueKey":"oneOf.0.function","typeLabel":"object"},"name":{"type":"string","description":"This is the name of the tool. This will be passed to the model.\n\nMust be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 40.","maxLength":40,"pattern":"/^[a-zA-Z0-9_-]{1,40}$/","uniqueKey":"oneOf.0.name","typeLabel":"string"},"description":{"type":"string","description":"This is the description of the tool. This will be passed to the model.","maxLength":1000,"uniqueKey":"oneOf.0.description","typeLabel":"string"},"url":{"type":"string","description":"This is where the request will be sent.","uniqueKey":"oneOf.0.url","typeLabel":"string"},"body":{"type":"object","description":"This is the body of the request.","required":["type"],"properties":{"type":{"type":"string","description":"This is the type of output you'd like.\n\n`string`, `number`, `integer`, `boolean` are the primitive types and should be obvious.\n\n`array` and `object` are more interesting and quite powerful. They allow you to define nested structures.\n\nFor `array`, you can define the schema of the items in the array using the `items` property.\n\nFor `object`, you can define the properties of the object using the `properties` property.","enum":["string","number","integer","boolean","array","object"],"isRequired":true,"uniqueKey":"oneOf.0.body.type","typeLabel":"enum\u003cstring>"},"items":{"type":"object","description":"This is required if the type is \"array\". This is the schema of the items in the array.\n\nThis is of type JsonSchema. However, Swagger doesn't support circular references.","uniqueKey":"oneOf.0.body.\\items","typeLabel":"object"},"properties":{"type":"object","description":"This is required if the type is \"object\". This specifies the properties of the object.\n\nThis is a map of string to JsonSchema. However, Swagger doesn't support circular references.","uniqueKey":"oneOf.0.body.properties","typeLabel":"object"},"description":{"type":"string","description":"This is the description to help the model understand what it needs to output.","uniqueKey":"oneOf.0.body.description","typeLabel":"string"},"pattern":{"type":"string","description":"This is the pattern of the string. This is a regex that will be used to validate the data in question. To use a common format, use the `format` property instead.\n\nOpenAI documentation: https://platform.openai.com/docs/guides/structured-outputs#supported-properties","uniqueKey":"oneOf.0.body.pattern","typeLabel":"string"},"format":{"type":"string","description":"This is the format of the string. To pass a regex, use the `pattern` property instead.\n\nOpenAI documentation: https://platform.openai.com/docs/guides/structured-outputs?api-mode=chat\u0026type-restrictions=string-restrictions","enum":["date-time","time","date","duration","email","hostname","ipv4","ipv6","uuid"],"uniqueKey":"oneOf.0.body.format","typeLabel":"enum\u003cstring>"},"required":{"description":"This is a list of properties that are required.\n\nThis only makes sense if the type is \"object\".","type":"array","items":{"type":"string","uniqueKey":"oneOf.0.body.required.items.[INDEX]","typeLabel":"string"},"uniqueKey":"oneOf.0.body.required","typeLabel":"string[]"},"enum":{"description":"This array specifies the allowed values that can be used to restrict the output of the model.","type":"array","items":{"type":"string","uniqueKey":"oneOf.0.body.enum.items.[INDEX]","typeLabel":"string"},"uniqueKey":"oneOf.0.body.enum","typeLabel":"string[]"},"title":{"type":"string","description":"This is the title of the schema.","uniqueKey":"oneOf.0.body.title","typeLabel":"string"}},"uniqueKey":"oneOf.0.body","typeLabel":"object"},"headers":{"type":"object","description":"These are the headers to send in the request.","required":["type"],"properties":{"type":{"type":"string","description":"This is the type of output you'd like.\n\n`string`, `number`, `integer`, `boolean` are the primitive types and should be obvious.\n\n`array` and `object` are more interesting and quite powerful. They allow you to define nested structures.\n\nFor `array`, you can define the schema of the items in the array using the `items` property.\n\nFor `object`, you can define the properties of the object using the `properties` property.","enum":["string","number","integer","boolean","array","object"],"isRequired":true,"uniqueKey":"oneOf.0.headers.type","typeLabel":"enum\u003cstring>"},"items":{"type":"object","description":"This is required if the type is \"array\". This is the schema of the items in the array.\n\nThis is of type JsonSchema. However, Swagger doesn't support circular references.","uniqueKey":"oneOf.0.headers.\\items","typeLabel":"object"},"properties":{"type":"object","description":"This is required if the type is \"object\". This specifies the properties of the object.\n\nThis is a map of string to JsonSchema. However, Swagger doesn't support circular references.","uniqueKey":"oneOf.0.headers.properties","typeLabel":"object"},"description":{"type":"string","description":"This is the description to help the model understand what it needs to output.","uniqueKey":"oneOf.0.headers.description","typeLabel":"string"},"pattern":{"type":"string","description":"This is the pattern of the string. This is a regex that will be used to validate the data in question. To use a common format, use the `format` property instead.\n\nOpenAI documentation: https://platform.openai.com/docs/guides/structured-outputs#supported-properties","uniqueKey":"oneOf.0.headers.pattern","typeLabel":"string"},"format":{"type":"string","description":"This is the format of the string. To pass a regex, use the `pattern` property instead.\n\nOpenAI documentation: https://platform.openai.com/docs/guides/structured-outputs?api-mode=chat\u0026type-restrictions=string-restrictions","enum":["date-time","time","date","duration","email","hostname","ipv4","ipv6","uuid"],"uniqueKey":"oneOf.0.headers.format","typeLabel":"enum\u003cstring>"},"required":{"description":"This is a list of properties that are required.\n\nThis only makes sense if the type is \"object\".","type":"array","items":{"type":"string","uniqueKey":"oneOf.0.headers.required.items.[INDEX]","typeLabel":"string"},"uniqueKey":"oneOf.0.headers.required","typeLabel":"string[]"},"enum":{"description":"This array specifies the allowed values that can be used to restrict the output of the model.","type":"array","items":{"type":"string","uniqueKey":"oneOf.0.headers.enum.items.[INDEX]","typeLabel":"string"},"uniqueKey":"oneOf.0.headers.enum","typeLabel":"string[]"},"title":{"type":"string","description":"This is the title of the schema.","uniqueKey":"oneOf.0.headers.title","typeLabel":"string"}},"uniqueKey":"oneOf.0.headers","typeLabel":"object"},"backoffPlan":{"type":"object","description":"This is the backoff plan if the request fails. Defaults to undefined (the request will not be retried).\n\n@default undefined (the request will not be retried)","required":["type","maxRetries","baseDelaySeconds"],"properties":{"type":{"type":"object","description":"This is the type of backoff plan to use. Defaults to fixed.\n\n@default fixed","enum":["fixed","exponential"],"example":"fixed","isRequired":true,"uniqueKey":"oneOf.0.backoffPlan.type","typeLabel":"object"},"maxRetries":{"type":"number","description":"This is the maximum number of retries to attempt if the request fails. Defaults to 0 (no retries).\n\n@default 0","minimum":0,"maximum":10,"example":0,"isRequired":true,"uniqueKey":"oneOf.0.backoffPlan.maxRetries","typeLabel":"number"},"baseDelaySeconds":{"type":"number","description":"This is the base delay in seconds. For linear backoff, this is the delay between each retry. For exponential backoff, this is the initial delay.","minimum":0,"maximum":10,"example":1,"isRequired":true,"uniqueKey":"oneOf.0.backoffPlan.baseDelaySeconds","typeLabel":"number"}},"uniqueKey":"oneOf.0.backoffPlan","typeLabel":"object"},"variableExtractionPlan":{"type":"object","description":"This is the plan to extract variables from the tool's response. These will be accessible during the call and stored in `call.artifact.variableValues` after the call.\n\nUsage:\n1. Use `aliases` to extract variables from the tool's response body. (Most common case)\n\n```json\n{\n \"aliases\": [\n {\n \"key\": \"customerName\",\n \"value\": \"{{customer.name}}\"\n },\n {\n \"key\": \"customerAge\",\n \"value\": \"{{customer.age}}\"\n }\n ]\n}\n```\n\nThe tool response body is made available to the liquid template.\n\n2. Use `aliases` to extract variables from the tool's response body if the response is an array.\n\n```json\n{\n \"aliases\": [\n {\n \"key\": \"customerName\",\n \"value\": \"{{$[0].name}}\"\n },\n {\n \"key\": \"customerAge\",\n \"value\": \"{{$[0].age}}\"\n }\n ]\n}\n```\n\n$ is a shorthand for the tool's response body. `$[0]` is the first item in the array. `$[n]` is the nth item in the array. Note, $ is available regardless of the response body type (both object and array).\n\n3. Use `aliases` to extract variables from the tool's response headers.\n\n```json\n{\n \"aliases\": [\n {\n \"key\": \"customerName\",\n \"value\": \"{{tool.response.headers.customer-name}}\"\n },\n {\n \"key\": \"customerAge\",\n \"value\": \"{{tool.response.headers.customer-age}}\"\n }\n ]\n}\n```\n\n`tool.response` is made available to the liquid template. Particularly, both `tool.response.headers` and `tool.response.body` are available. Note, `tool.response` is available regardless of the response body type (both object and array).\n\n4. Use `schema` to extract a large portion of the tool's response body.\n\n4.1. If you hit example.com and it returns `{\"name\": \"John\", \"age\": 30}`, then you can specify the schema as:\n\n```json\n{\n \"schema\": {\n \"type\": \"object\",\n \"properties\": {\n \"name\": {\n \"type\": \"string\"\n },\n \"age\": {\n \"type\": \"number\"\n }\n }\n }\n}\n```\n\n4.2. If you hit example.com and it returns `{\"name\": {\"first\": \"John\", \"last\": \"Doe\"}}`, then you can specify the schema as:\n\n```json\n{\n \"schema\": {\n \"type\": \"object\",\n \"properties\": {\n \"name\": {\n \"type\": \"object\",\n \"properties\": {\n \"first\": {\n \"type\": \"string\"\n },\n \"last\": {\n \"type\": \"string\"\n }\n }\n }\n }\n }\n}\n```\n\nThese will be extracted as `{{ name }}` and `{{ age }}` respectively. To emphasize, object properties are extracted as direct global variables.\n\n4.3. If you hit example.com and it returns `{\"name\": {\"first\": \"John\", \"last\": \"Doe\"}}`, then you can specify the schema as:\n\n```json\n{\n \"schema\": {\n \"type\": \"object\",\n \"properties\": {\n \"name\": {\n \"type\": \"object\",\n \"properties\": {\n \"first\": {\n \"type\": \"string\"\n },\n \"last\": {\n \"type\": \"string\"\n }\n }\n }\n }\n }\n}\n```\n\nThese will be extracted as `{{ name }}`. And, `{{ name.first }}` and `{{ name.last }}` will be accessible.\n\n4.4. If you hit example.com and it returns `[\"94123\", \"94124\"]`, then you can specify the schema as:\n\n```json\n{\n \"schema\": {\n \"type\": \"array\",\n \"title\": \"zipCodes\",\n \"items\": {\n \"type\": \"string\"\n }\n }\n}\n```\n\nThis will be extracted as `{{ zipCodes }}`. To access the array items, you can use `{{ zipCodes[0] }}` and `{{ zipCodes[1] }}`.\n\n4.5. If you hit example.com and it returns `[{\"name\": \"John\", \"age\": 30, \"zipCodes\": [\"94123\", \"94124\"]}, {\"name\": \"Jane\", \"age\": 25, \"zipCodes\": [\"94125\", \"94126\"]}]`, then you can specify the schema as:\n\n```json\n{\n \"schema\": {\n \"type\": \"array\",\n \"title\": \"people\",\n \"items\": {\n \"type\": \"object\",\n \"properties\": {\n \"name\": {\n \"type\": \"string\"\n },\n \"age\": {\n \"type\": \"number\"\n },\n \"zipCodes\": {\n \"type\": \"array\",\n \"items\": {\n \"type\": \"string\"\n }\n }\n }\n }\n }\n}\n```\n\nThis will be extracted as `{{ people }}`. To access the array items, you can use `{{ people[n].name }}`, `{{ people[n].age }}`, `{{ people[n].zipCodes }}`, `{{ people[n].zipCodes[0] }}` and `{{ people[n].zipCodes[1] }}`.\n\nNote: Both `aliases` and `schema` can be used together.","properties":{"schema":{"type":"object","description":"This is the schema to extract.\n\nExamples:\n1. To extract object properties, you can use the following schema:\n```json\n{\n \"type\": \"object\",\n \"properties\": {\n \"name\": {\n \"type\": \"string\"\n },\n \"age\": {\n \"type\": \"number\"\n }\n }\n}\n```\n\nThese will be extracted as `{{ name }}` and `{{ age }}` respectively. To emphasize, object properties are extracted as direct global variables.\n\n2. To extract nested properties, you can use the following schema:\n```json\n{\n \"type\": \"object\",\n \"properties\": {\n \"name\": {\n \"type\": \"object\",\n \"properties\": {\n \"first\": {\n \"type\": \"string\"\n },\n \"last\": {\n \"type\": \"string\"\n }\n }\n }\n }\n}\n```\n\nThese will be extracted as `{{ name }}`. And, `{{ name.first }}` and `{{ name.last }}` will be accessible.\n\n3. To extract array items, you can use the following schema:\n```json\n{\n \"type\": \"array\",\n \"title\": \"zipCodes\",\n \"items\": {\n \"type\": \"string\"\n }\n}\n```\n\nThis will be extracted as `{{ zipCodes }}`. To access the array items, you can use `{{ zipCodes[0] }}` and `{{ zipCodes[1] }}`.\n\n4. To extract array of objects, you can use the following schema:\n\n```json\n{\n \"type\": \"array\",\n \"name\": \"people\",\n \"items\": {\n \"type\": \"object\",\n \"properties\": {\n \"name\": {\n \"type\": \"string\"\n },\n \"age\": {\n \"type\": \"number\"\n },\n \"zipCodes\": {\n \"type\": \"array\",\n \"items\": {\n \"type\": \"string\"\n }\n }\n }\n }\n}\n```\n\nThis will be extracted as `{{ people }}`. To access the array items, you can use `{{ people[n].name }}`, `{{ people[n].age }}`, `{{ people[n].zipCodes }}`, `{{ people[n].zipCodes[0] }}` and `{{ people[n].zipCodes[1] }}`.","required":["type"],"properties":{"type":{"type":"string","description":"This is the type of output you'd like.\n\n`string`, `number`, `integer`, `boolean` are the primitive types and should be obvious.\n\n`array` and `object` are more interesting and quite powerful. They allow you to define nested structures.\n\nFor `array`, you can define the schema of the items in the array using the `items` property.\n\nFor `object`, you can define the properties of the object using the `properties` property.","enum":["string","number","integer","boolean","array","object"],"isRequired":true,"uniqueKey":"oneOf.0.variableExtractionPlan.schema.type","typeLabel":"enum\u003cstring>"},"items":{"type":"object","description":"This is required if the type is \"array\". This is the schema of the items in the array.\n\nThis is of type JsonSchema. However, Swagger doesn't support circular references.","uniqueKey":"oneOf.0.variableExtractionPlan.schema.\\items","typeLabel":"object"},"properties":{"type":"object","description":"This is required if the type is \"object\". This specifies the properties of the object.\n\nThis is a map of string to JsonSchema. However, Swagger doesn't support circular references.","uniqueKey":"oneOf.0.variableExtractionPlan.schema.properties","typeLabel":"object"},"description":{"type":"string","description":"This is the description to help the model understand what it needs to output.","uniqueKey":"oneOf.0.variableExtractionPlan.schema.description","typeLabel":"string"},"pattern":{"type":"string","description":"This is the pattern of the string. This is a regex that will be used to validate the data in question. To use a common format, use the `format` property instead.\n\nOpenAI documentation: https://platform.openai.com/docs/guides/structured-outputs#supported-properties","uniqueKey":"oneOf.0.variableExtractionPlan.schema.pattern","typeLabel":"string"},"format":{"type":"string","description":"This is the format of the string. To pass a regex, use the `pattern` property instead.\n\nOpenAI documentation: https://platform.openai.com/docs/guides/structured-outputs?api-mode=chat\u0026type-restrictions=string-restrictions","enum":["date-time","time","date","duration","email","hostname","ipv4","ipv6","uuid"],"uniqueKey":"oneOf.0.variableExtractionPlan.schema.format","typeLabel":"enum\u003cstring>"},"required":{"description":"This is a list of properties that are required.\n\nThis only makes sense if the type is \"object\".","type":"array","items":{"type":"string","uniqueKey":"oneOf.0.variableExtractionPlan.schema.required.items.[INDEX]","typeLabel":"string"},"uniqueKey":"oneOf.0.variableExtractionPlan.schema.required","typeLabel":"string[]"},"enum":{"description":"This array specifies the allowed values that can be used to restrict the output of the model.","type":"array","items":{"type":"string","uniqueKey":"oneOf.0.variableExtractionPlan.schema.enum.items.[INDEX]","typeLabel":"string"},"uniqueKey":"oneOf.0.variableExtractionPlan.schema.enum","typeLabel":"string[]"},"title":{"type":"string","description":"This is the title of the schema.","uniqueKey":"oneOf.0.variableExtractionPlan.schema.title","typeLabel":"string"}},"uniqueKey":"oneOf.0.variableExtractionPlan.schema","typeLabel":"object"},"aliases":{"description":"These are additional variables to create.\n\nThese will be accessible during the call as `{{key}}` and stored in `call.artifact.variableValues` after the call.\n\nExample:\n```json\n{\n \"aliases\": [\n {\n \"key\": \"customerName\",\n \"value\": \"{{name}}\"\n },\n {\n \"key\": \"fullName\",\n \"value\": \"{{firstName}} {{lastName}}\"\n },\n {\n \"key\": \"greeting\",\n \"value\": \"Hello {{name}}, welcome to {{company}}!\"\n },\n {\n \"key\": \"customerEmail\",\n \"value\": \"{{addresses[0].city}}\"\n },\n {\n \"key\": \"something\",\n \"value\": \"{{any liquid}}\"\n }\n ]\n}\n```\n\nThis will create variables `customerName`, `fullName`, `customerEmail`, `greeting`, and `something`. To access these variables, you can reference them as `{{customerName}}`, `{{fullName}}`, `{{customerEmail}}`, `{{greeting}}`, and `{{something}}`.","type":"array","items":{"type":"object","properties":{"key":{"type":"string","description":"This is the key of the variable.\n\nThis variable will be accessible during the call as `{{key}}` and stored in `call.artifact.variableValues` after the call.\n\nRules:\n- Must start with a letter (a-z, A-Z).\n- Subsequent characters can be letters, numbers, or underscores.\n- Minimum length of 1 and maximum length of 40.","minLength":1,"maxLength":40,"pattern":"/^[a-zA-Z][a-zA-Z0-9_]*$/","isRequired":true,"uniqueKey":"oneOf.0.variableExtractionPlan.aliases.items.[INDEX].key","typeLabel":"string"},"value":{"type":"string","description":"This is the value of the variable.\n\nThis can reference existing variables, use filters, and perform transformations.\n\nExamples: \"{{name}}\", \"{{customer.email}}\", \"Hello {{name | upcase}}\"","maxLength":10000,"isRequired":true,"uniqueKey":"oneOf.0.variableExtractionPlan.aliases.items.[INDEX].value","typeLabel":"string"}},"required":["key","value"],"uniqueKey":"oneOf.0.variableExtractionPlan.aliases.items.[INDEX]","typeLabel":"object"},"uniqueKey":"oneOf.0.variableExtractionPlan.aliases","typeLabel":"object[]"}},"uniqueKey":"oneOf.0.variableExtractionPlan","typeLabel":"object"}},"uniqueKey":"oneOf.0","typeLabel":"ApiRequestTool · object"},{"type":"object","title":"DtmfTool","properties":{"messages":{"type":"array","description":"These are the messages that will be spoken to the user as the tool is running.\n\nFor some tools, this is auto-filled based on special fields like `tool.destinations`. For others like the function tool, these can be custom configured.","items":{"oneOf":[{"type":"object","title":"ToolMessageStart","required":["type"],"properties":{"type":{"type":"string","enum":["request-start"],"description":"This message is triggered when the tool call starts.\n\nThis message is never triggered for async tools.\n\nIf this message is not provided, one of the default filler messages \"Hold on a sec\", \"One moment\", \"Just a sec\", \"Give me a moment\" or \"This'll just take a sec\" will be used.","isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.0.type","typeLabel":"enum\u003cstring>"},"contents":{"type":"array","description":"This is an alternative to the `content` property. It allows to specify variants of the same content, one per language.\n\nUsage:\n- If your assistants are multilingual, you can provide content for each language.\n- If you don't provide content for a language, the first item in the array will be automatically translated to the active language at that moment.\n\nThis will override the `content` property.","items":{"type":"object","title":"Text","required":["type","text","language"],"properties":{"type":{"type":"string","enum":["text"],"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.0.contents.items.[INDEX].type","typeLabel":"enum\u003cstring>"},"text":{"type":"string","isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.0.contents.items.[INDEX].text","typeLabel":"string"},"language":{"type":"string","enum":["aa","ab","ae","af","ak","am","an","ar","as","av","ay","az","ba","be","bg","bh","bi","bm","bn","bo","br","bs","ca","ce","ch","co","cr","cs","cu","cv","cy","da","de","dv","dz","ee","el","en","eo","es","et","eu","fa","ff","fi","fj","fo","fr","fy","ga","gd","gl","gn","gu","gv","ha","he","hi","ho","hr","ht","hu","hy","hz","ia","id","ie","ig","ii","ik","io","is","it","iu","ja","jv","ka","kg","ki","kj","kk","kl","km","kn","ko","kr","ks","ku","kv","kw","ky","la","lb","lg","li","ln","lo","lt","lu","lv","mg","mh","mi","mk","ml","mn","mr","ms","mt","my","na","nb","nd","ne","ng","nl","nn","no","nr","nv","ny","oc","oj","om","or","os","pa","pi","pl","ps","pt","qu","rm","rn","ro","ru","rw","sa","sc","sd","se","sg","si","sk","sl","sm","sn","so","sq","sr","ss","st","su","sv","sw","ta","te","tg","th","ti","tk","tl","tn","to","tr","ts","tt","tw","ty","ug","uk","ur","uz","ve","vi","vo","wa","wo","xh","yi","yue","yo","za","zh","zu"],"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.0.contents.items.[INDEX].language","typeLabel":"enum\u003cstring>"}},"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.0.contents.items.[INDEX]","typeLabel":"Text · object"},"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.0.contents","typeLabel":"Text · object[]"},"blocking":{"type":"boolean","description":"This is an optional boolean that if true, the tool call will only trigger after the message is spoken. Default is false.\n\n@default false","example":false,"default":false,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.0.blocking","typeLabel":"boolean"},"content":{"type":"string","description":"This is the content that the assistant says when this message is triggered.","maxLength":1000,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.0.content","typeLabel":"string"},"conditions":{"description":"This is an optional array of conditions that the tool call arguments must meet in order for this message to be triggered.","type":"array","items":{"type":"object","properties":{"operator":{"type":"string","description":"This is the operator you want to use to compare the parameter and value.","enum":["eq","neq","gt","gte","lt","lte"],"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.0.conditions.items.[INDEX].operator","typeLabel":"enum\u003cstring>"},"param":{"type":"string","description":"This is the name of the parameter that you want to check.","maxLength":1000,"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.0.conditions.items.[INDEX].param","typeLabel":"string"},"value":{"type":"string","description":"This is the value you want to compare against the parameter.","maxLength":1000,"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.0.conditions.items.[INDEX].value","typeLabel":"string"}},"required":["operator","param","value"],"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.0.conditions.items.[INDEX]","typeLabel":"object"},"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.0.conditions","typeLabel":"object[]"}},"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.0","typeLabel":"ToolMessageStart · object"},{"type":"object","title":"ToolMessageComplete","required":["type"],"properties":{"type":{"type":"string","description":"This message is triggered when the tool call is complete.\n\nThis message is triggered immediately without waiting for your server to respond for async tool calls.\n\nIf this message is not provided, the model will be requested to respond.\n\nIf this message is provided, only this message will be spoken and the model will not be requested to come up with a response. It's an exclusive OR.","enum":["request-complete"],"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.1.type","typeLabel":"enum\u003cstring>"},"contents":{"type":"array","description":"This is an alternative to the `content` property. It allows to specify variants of the same content, one per language.\n\nUsage:\n- If your assistants are multilingual, you can provide content for each language.\n- If you don't provide content for a language, the first item in the array will be automatically translated to the active language at that moment.\n\nThis will override the `content` property.","items":{"type":"object","title":"Text","required":["type","text","language"],"properties":{"type":{"type":"string","enum":["text"],"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.1.contents.items.[INDEX].type","typeLabel":"enum\u003cstring>"},"text":{"type":"string","isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.1.contents.items.[INDEX].text","typeLabel":"string"},"language":{"type":"string","enum":["aa","ab","ae","af","ak","am","an","ar","as","av","ay","az","ba","be","bg","bh","bi","bm","bn","bo","br","bs","ca","ce","ch","co","cr","cs","cu","cv","cy","da","de","dv","dz","ee","el","en","eo","es","et","eu","fa","ff","fi","fj","fo","fr","fy","ga","gd","gl","gn","gu","gv","ha","he","hi","ho","hr","ht","hu","hy","hz","ia","id","ie","ig","ii","ik","io","is","it","iu","ja","jv","ka","kg","ki","kj","kk","kl","km","kn","ko","kr","ks","ku","kv","kw","ky","la","lb","lg","li","ln","lo","lt","lu","lv","mg","mh","mi","mk","ml","mn","mr","ms","mt","my","na","nb","nd","ne","ng","nl","nn","no","nr","nv","ny","oc","oj","om","or","os","pa","pi","pl","ps","pt","qu","rm","rn","ro","ru","rw","sa","sc","sd","se","sg","si","sk","sl","sm","sn","so","sq","sr","ss","st","su","sv","sw","ta","te","tg","th","ti","tk","tl","tn","to","tr","ts","tt","tw","ty","ug","uk","ur","uz","ve","vi","vo","wa","wo","xh","yi","yue","yo","za","zh","zu"],"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.1.contents.items.[INDEX].language","typeLabel":"enum\u003cstring>"}},"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.1.contents.items.[INDEX]","typeLabel":"Text · object"},"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.1.contents","typeLabel":"Text · object[]"},"role":{"type":"string","description":"This is optional and defaults to \"assistant\".\n\nWhen role=assistant, `content` is said out loud.\n\nWhen role=system, `content` is passed to the model in a system message. Example:\n system: default one\n assistant:\n user:\n assistant:\n user:\n assistant:\n user:\n assistant: tool called\n tool: your server response\n \u003c--- system prompt as hint\n ---> model generates response which is spoken\nThis is useful when you want to provide a hint to the model about what to say next.","enum":["assistant","system"],"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.1.role","typeLabel":"enum\u003cstring>"},"endCallAfterSpokenEnabled":{"type":"boolean","description":"This is an optional boolean that if true, the call will end after the message is spoken. Default is false.\n\nThis is ignored if `role` is set to `system`.\n\n@default false","example":false,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.1.endCallAfterSpokenEnabled","typeLabel":"boolean"},"content":{"type":"string","description":"This is the content that the assistant says when this message is triggered.","maxLength":1000,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.1.content","typeLabel":"string"},"conditions":{"description":"This is an optional array of conditions that the tool call arguments must meet in order for this message to be triggered.","type":"array","items":{"type":"object","properties":{"operator":{"type":"string","description":"This is the operator you want to use to compare the parameter and value.","enum":["eq","neq","gt","gte","lt","lte"],"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.1.conditions.items.[INDEX].operator","typeLabel":"enum\u003cstring>"},"param":{"type":"string","description":"This is the name of the parameter that you want to check.","maxLength":1000,"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.1.conditions.items.[INDEX].param","typeLabel":"string"},"value":{"type":"string","description":"This is the value you want to compare against the parameter.","maxLength":1000,"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.1.conditions.items.[INDEX].value","typeLabel":"string"}},"required":["operator","param","value"],"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.1.conditions.items.[INDEX]","typeLabel":"object"},"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.1.conditions","typeLabel":"object[]"}},"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.1","typeLabel":"ToolMessageComplete · object"},{"type":"object","title":"ToolMessageFailed","required":["type"],"properties":{"type":{"type":"string","description":"This message is triggered when the tool call fails.\n\nThis message is never triggered for async tool calls.\n\nIf this message is not provided, the model will be requested to respond.\n\nIf this message is provided, only this message will be spoken and the model will not be requested to come up with a response. It's an exclusive OR.","enum":["request-failed"],"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.2.type","typeLabel":"enum\u003cstring>"},"contents":{"type":"array","description":"This is an alternative to the `content` property. It allows to specify variants of the same content, one per language.\n\nUsage:\n- If your assistants are multilingual, you can provide content for each language.\n- If you don't provide content for a language, the first item in the array will be automatically translated to the active language at that moment.\n\nThis will override the `content` property.","items":{"type":"object","title":"Text","required":["type","text","language"],"properties":{"type":{"type":"string","enum":["text"],"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.2.contents.items.[INDEX].type","typeLabel":"enum\u003cstring>"},"text":{"type":"string","isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.2.contents.items.[INDEX].text","typeLabel":"string"},"language":{"type":"string","enum":["aa","ab","ae","af","ak","am","an","ar","as","av","ay","az","ba","be","bg","bh","bi","bm","bn","bo","br","bs","ca","ce","ch","co","cr","cs","cu","cv","cy","da","de","dv","dz","ee","el","en","eo","es","et","eu","fa","ff","fi","fj","fo","fr","fy","ga","gd","gl","gn","gu","gv","ha","he","hi","ho","hr","ht","hu","hy","hz","ia","id","ie","ig","ii","ik","io","is","it","iu","ja","jv","ka","kg","ki","kj","kk","kl","km","kn","ko","kr","ks","ku","kv","kw","ky","la","lb","lg","li","ln","lo","lt","lu","lv","mg","mh","mi","mk","ml","mn","mr","ms","mt","my","na","nb","nd","ne","ng","nl","nn","no","nr","nv","ny","oc","oj","om","or","os","pa","pi","pl","ps","pt","qu","rm","rn","ro","ru","rw","sa","sc","sd","se","sg","si","sk","sl","sm","sn","so","sq","sr","ss","st","su","sv","sw","ta","te","tg","th","ti","tk","tl","tn","to","tr","ts","tt","tw","ty","ug","uk","ur","uz","ve","vi","vo","wa","wo","xh","yi","yue","yo","za","zh","zu"],"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.2.contents.items.[INDEX].language","typeLabel":"enum\u003cstring>"}},"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.2.contents.items.[INDEX]","typeLabel":"Text · object"},"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.2.contents","typeLabel":"Text · object[]"},"endCallAfterSpokenEnabled":{"type":"boolean","description":"This is an optional boolean that if true, the call will end after the message is spoken. Default is false.\n\n@default false","example":false,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.2.endCallAfterSpokenEnabled","typeLabel":"boolean"},"content":{"type":"string","description":"This is the content that the assistant says when this message is triggered.","maxLength":1000,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.2.content","typeLabel":"string"},"conditions":{"description":"This is an optional array of conditions that the tool call arguments must meet in order for this message to be triggered.","type":"array","items":{"type":"object","properties":{"operator":{"type":"string","description":"This is the operator you want to use to compare the parameter and value.","enum":["eq","neq","gt","gte","lt","lte"],"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.2.conditions.items.[INDEX].operator","typeLabel":"enum\u003cstring>"},"param":{"type":"string","description":"This is the name of the parameter that you want to check.","maxLength":1000,"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.2.conditions.items.[INDEX].param","typeLabel":"string"},"value":{"type":"string","description":"This is the value you want to compare against the parameter.","maxLength":1000,"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.2.conditions.items.[INDEX].value","typeLabel":"string"}},"required":["operator","param","value"],"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.2.conditions.items.[INDEX]","typeLabel":"object"},"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.2.conditions","typeLabel":"object[]"}},"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.2","typeLabel":"ToolMessageFailed · object"},{"type":"object","title":"ToolMessageDelayed","required":["type"],"properties":{"type":{"type":"string","description":"This message is triggered when the tool call is delayed.\n\nThere are the two things that can trigger this message:\n1. The user talks with the assistant while your server is processing the request. Default is \"Sorry, a few more seconds.\"\n2. The server doesn't respond within `timingMilliseconds`.\n\nThis message is never triggered for async tool calls.","enum":["request-response-delayed"],"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.3.type","typeLabel":"enum\u003cstring>"},"contents":{"type":"array","description":"This is an alternative to the `content` property. It allows to specify variants of the same content, one per language.\n\nUsage:\n- If your assistants are multilingual, you can provide content for each language.\n- If you don't provide content for a language, the first item in the array will be automatically translated to the active language at that moment.\n\nThis will override the `content` property.","items":{"type":"object","title":"Text","required":["type","text","language"],"properties":{"type":{"type":"string","enum":["text"],"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.3.contents.items.[INDEX].type","typeLabel":"enum\u003cstring>"},"text":{"type":"string","isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.3.contents.items.[INDEX].text","typeLabel":"string"},"language":{"type":"string","enum":["aa","ab","ae","af","ak","am","an","ar","as","av","ay","az","ba","be","bg","bh","bi","bm","bn","bo","br","bs","ca","ce","ch","co","cr","cs","cu","cv","cy","da","de","dv","dz","ee","el","en","eo","es","et","eu","fa","ff","fi","fj","fo","fr","fy","ga","gd","gl","gn","gu","gv","ha","he","hi","ho","hr","ht","hu","hy","hz","ia","id","ie","ig","ii","ik","io","is","it","iu","ja","jv","ka","kg","ki","kj","kk","kl","km","kn","ko","kr","ks","ku","kv","kw","ky","la","lb","lg","li","ln","lo","lt","lu","lv","mg","mh","mi","mk","ml","mn","mr","ms","mt","my","na","nb","nd","ne","ng","nl","nn","no","nr","nv","ny","oc","oj","om","or","os","pa","pi","pl","ps","pt","qu","rm","rn","ro","ru","rw","sa","sc","sd","se","sg","si","sk","sl","sm","sn","so","sq","sr","ss","st","su","sv","sw","ta","te","tg","th","ti","tk","tl","tn","to","tr","ts","tt","tw","ty","ug","uk","ur","uz","ve","vi","vo","wa","wo","xh","yi","yue","yo","za","zh","zu"],"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.3.contents.items.[INDEX].language","typeLabel":"enum\u003cstring>"}},"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.3.contents.items.[INDEX]","typeLabel":"Text · object"},"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.3.contents","typeLabel":"Text · object[]"},"timingMilliseconds":{"type":"number","minimum":100,"maximum":120000,"example":1000,"description":"The number of milliseconds to wait for the server response before saying this message.","uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.3.timingMilliseconds","typeLabel":"number"},"content":{"type":"string","description":"This is the content that the assistant says when this message is triggered.","maxLength":1000,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.3.content","typeLabel":"string"},"conditions":{"description":"This is an optional array of conditions that the tool call arguments must meet in order for this message to be triggered.","type":"array","items":{"type":"object","properties":{"operator":{"type":"string","description":"This is the operator you want to use to compare the parameter and value.","enum":["eq","neq","gt","gte","lt","lte"],"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.3.conditions.items.[INDEX].operator","typeLabel":"enum\u003cstring>"},"param":{"type":"string","description":"This is the name of the parameter that you want to check.","maxLength":1000,"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.3.conditions.items.[INDEX].param","typeLabel":"string"},"value":{"type":"string","description":"This is the value you want to compare against the parameter.","maxLength":1000,"isRequired":true,"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.3.conditions.items.[INDEX].value","typeLabel":"string"}},"required":["operator","param","value"],"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.3.conditions.items.[INDEX]","typeLabel":"object"},"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.3.conditions","typeLabel":"object[]"}},"uniqueKey":"oneOf.1.messages.items.[INDEX].oneOf.3","typeLabel":"ToolMessageDelayed · object"}],"uniqueKey":"oneOf.1.messages.items.[INDEX]","typeLabel":"ToolMessageStart · object | ToolMessageComplete · object | ToolMessageFailed · object | ToolMessageDelayed · object"},"uniqueKey":"oneOf.1.messages","typeLabel":"(ToolMessageStart · object | ToolMessageComplete · object | ToolMessageFailed · object | ToolMessageDelayed · object)[]"},"function":{"type":"object","description":"This is the function definition of the tool.\n\nFor `endCall`, `transferCall`, and `dtmf` tools, this is auto-filled based on tool-specific fields like `tool.destinations`. But, even in those cases, you can provide a custom function definition for advanced use cases.\n\nAn example of an advanced use case is if you want to customize the message that's spoken for `endCall` tool. You can specify a function where it returns an argument \"reason\". Then, in `messages` array, you can have many \"request-complete\" messages. One of these messages will be triggered if the `messages[].conditions` matches the \"reason\" argument.","required":["name"],"properties":{"name":{"type":"string","description":"This is the the name of the function to be called.\n\nMust be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.","maxLength":64,"pattern":"/^[a-zA-Z0-9_-]{1,64}$/","isRequired":true,"uniqueKey":"oneOf.1.function.name","typeLabel":"string"},"strict":{"type":"boolean","description":"This is a boolean that controls whether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the parameters field. Only a subset of JSON Schema is supported when strict is true. Learn more about Structured Outputs in the [OpenAI guide](https://openai.com/index/introducing-structured-outputs-in-the-api/).\n\n@default false","default":false,"uniqueKey":"oneOf.1.function.strict","typeLabel":"boolean"},"description":{"type":"string","description":"This is the description of what the function does, used by the AI to choose when and how to call the function.","maxLength":1000,"uniqueKey":"oneOf.1.function.description","typeLabel":"string"},"parameters":{"type":"object","description":"These are the parameters the functions accepts, described as a JSON Schema object.\n\nSee the [OpenAI guide](https://platform.openai.com/docs/guides/function-calling) for examples, and the [JSON Schema reference](https://json-schema.org/understanding-json-schema) for documentation about the format.\n\nOmitting parameters defines a function with an empty parameter list.","required":["type","properties"],"properties":{"type":{"type":"string","description":"This must be set to 'object'. It instructs the model to return a JSON object containing the function call properties.","enum":["object"],"isRequired":true,"uniqueKey":"oneOf.1.function.parameters.type","typeLabel":"enum\u003cstring>"},"properties":{"type":"object","description":"This provides a description of the properties required by the function.\nJSON Schema can be used to specify expectations for each property.\nRefer to [this doc](https://ajv.js.org/json-schema.html#json-data-type) for a comprehensive guide on JSON Schema.","additionalProperties":{"type":"object","properties":{"type":{"type":"string","description":"This is the type of output you'd like.\n\n`string`, `number`, `integer`, `boolean` are the primitive types and should be obvious.\n\n`array` and `object` are more interesting and quite powerful. They allow you to define nested structures.\n\nFor `array`, you can define the schema of the items in the array using the `items` property.\n\nFor `object`, you can define the properties of the object using the `properties` property.","enum":["string","number","integer","boolean","array","object"],"isRequired":true,"uniqueKey":"oneOf.1.function.parameters.properties.additionalProperties.type","typeLabel":"enum\u003cstring>"},"items":{"type":"object","description":"This is required if the type is \"array\". This is the schema of the items in the array.\n\nThis is of type JsonSchema. However, Swagger doesn't support circular references.","uniqueKey":"oneOf.1.function.parameters.properties.additionalProperties.\\items","typeLabel":"object"},"properties":{"type":"object","description":"This is required if the type is \"object\". This specifies the properties of the object.\n\nThis is a map of string to JsonSchema. However, Swagger doesn't support circular references.","uniqueKey":"oneOf.1.function.parameters.properties.additionalProperties.properties","typeLabel":"object"},"description":{"type":"string","description":"This is the description to help the model understand what it needs to output.","uniqueKey":"oneOf.1.function.parameters.properties.additionalProperties.description","typeLabel":"string"},"pattern":{"type":"string","description":"This is the pattern of the string. This is a regex that will be used to validate the data in question. To use a common format, use the `format` property instead.\n\nOpenAI documentation: https://platform.openai.com/docs/guides/structured-outputs#supported-properties","uniqueKey":"oneOf.1.function.parameters.properties.additionalProperties.pattern","typeLabel":"string"},"format":{"type":"string","description":"This is the format of the string. To pass a regex, use the `pattern` property instead.\n\nOpenAI documentation: https://platform.openai.com/docs/guides/structured-outputs?api-mode=chat\u0026type-restrictions=string-restrictions","enum":["date-time","time","date","duration","email","hostname","ipv4","ipv6","uuid"],"uniqueKey":"oneOf.1.function.parameters.properties.additionalProperties.format","typeLabel":"enum\u003cstring>"},"required":{"description":"This is a list of properties that are required.\n\nThis only makes sense if the type is \"object\".","type":"array","items":{"type":"string","uniqueKey":"oneOf.1.function.parameters.properties.additionalProperties.required.items.[INDEX]","typeLabel":"string"},"uniqueKey":"oneOf.1.function.parameters.properties.additionalProperties.required","typeLabel":"string[]"},"enum":{"description":"This array specifies the allowed values that can be used to restrict the output of the model.","type":"array","items":{"type":"string","uniqueKey":"oneOf.1.function.parameters.properties.additionalProperties.enum.items.[INDEX]","typeLabel":"string"},"uniqueKey":"oneOf.1.function.parameters.properties.additionalProperties.enum","typeLabel":"string[]"},"title":{"type":"string","description":"This is the title of the schema.","uniqueKey":"oneOf.1.function.parameters.properties.additionalProperties.title","typeLabel":"string"}},"required":["type"],"uniqueKey":"oneOf.1.function.parameters.properties.additionalProperties","typeLabel":"object"},"isRequired":true,"uniqueKey":"oneOf.1.function.parameters.properties","typeLabel":"object"},"required":{"description":"This specifies the properties that are required by the function.","type":"array","items":{"type":"string","uniqueKey":"oneOf.1.function.parameters.required.items.[INDEX]","typeLabel":"string"},"uniqueKey":"oneOf.1.function.parameters.required","typeLabel":"string[]"}},"uniqueKey":"oneOf.1.function.parameters","typeLabel":"object"}},"uniqueKey":"oneOf.1.function","typeLabel":"object"}},"uniqueKey":"oneOf.1","typeLabel":"DtmfTool · object"},{"type":"object","title":"EndCallTool","properties":{"messages":{"type":"array","description":"These are the messages that will be spoken to the user as the tool is running.\n\nFor some tools, this is auto-filled based on special fields like `tool.destinations`. For others like the function tool, these can be custom configured.","items":{"oneOf":[{"type":"object","title":"ToolMessageStart","required":["type"],"properties":{"type":{"type":"string","enum":["request-start"],"description":"This message is triggered when the tool call starts.\n\nThis message is never triggered for async tools.\n\nIf this message is not provided, one of the default filler messages \"Hold on a sec\", \"One moment\", \"Just a sec\", \"Give me a moment\" or \"This'll just take a sec\" will be used.","isRequired":true,"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.0.type","typeLabel":"enum\u003cstring>"},"contents":{"type":"array","description":"This is an alternative to the `content` property. It allows to specify variants of the same content, one per language.\n\nUsage:\n- If your assistants are multilingual, you can provide content for each language.\n- If you don't provide content for a language, the first item in the array will be automatically translated to the active language at that moment.\n\nThis will override the `content` property.","items":{"type":"object","title":"Text","required":["type","text","language"],"properties":{"type":{"type":"string","enum":["text"],"isRequired":true,"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.0.contents.items.[INDEX].type","typeLabel":"enum\u003cstring>"},"text":{"type":"string","isRequired":true,"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.0.contents.items.[INDEX].text","typeLabel":"string"},"language":{"type":"string","enum":["aa","ab","ae","af","ak","am","an","ar","as","av","ay","az","ba","be","bg","bh","bi","bm","bn","bo","br","bs","ca","ce","ch","co","cr","cs","cu","cv","cy","da","de","dv","dz","ee","el","en","eo","es","et","eu","fa","ff","fi","fj","fo","fr","fy","ga","gd","gl","gn","gu","gv","ha","he","hi","ho","hr","ht","hu","hy","hz","ia","id","ie","ig","ii","ik","io","is","it","iu","ja","jv","ka","kg","ki","kj","kk","kl","km","kn","ko","kr","ks","ku","kv","kw","ky","la","lb","lg","li","ln","lo","lt","lu","lv","mg","mh","mi","mk","ml","mn","mr","ms","mt","my","na","nb","nd","ne","ng","nl","nn","no","nr","nv","ny","oc","oj","om","or","os","pa","pi","pl","ps","pt","qu","rm","rn","ro","ru","rw","sa","sc","sd","se","sg","si","sk","sl","sm","sn","so","sq","sr","ss","st","su","sv","sw","ta","te","tg","th","ti","tk","tl","tn","to","tr","ts","tt","tw","ty","ug","uk","ur","uz","ve","vi","vo","wa","wo","xh","yi","yue","yo","za","zh","zu"],"isRequired":true,"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.0.contents.items.[INDEX].language","typeLabel":"enum\u003cstring>"}},"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.0.contents.items.[INDEX]","typeLabel":"Text · object"},"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.0.contents","typeLabel":"Text · object[]"},"blocking":{"type":"boolean","description":"This is an optional boolean that if true, the tool call will only trigger after the message is spoken. Default is false.\n\n@default false","example":false,"default":false,"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.0.blocking","typeLabel":"boolean"},"content":{"type":"string","description":"This is the content that the assistant says when this message is triggered.","maxLength":1000,"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.0.content","typeLabel":"string"},"conditions":{"description":"This is an optional array of conditions that the tool call arguments must meet in order for this message to be triggered.","type":"array","items":{"type":"object","properties":{"operator":{"type":"string","description":"This is the operator you want to use to compare the parameter and value.","enum":["eq","neq","gt","gte","lt","lte"],"isRequired":true,"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.0.conditions.items.[INDEX].operator","typeLabel":"enum\u003cstring>"},"param":{"type":"string","description":"This is the name of the parameter that you want to check.","maxLength":1000,"isRequired":true,"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.0.conditions.items.[INDEX].param","typeLabel":"string"},"value":{"type":"string","description":"This is the value you want to compare against the parameter.","maxLength":1000,"isRequired":true,"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.0.conditions.items.[INDEX].value","typeLabel":"string"}},"required":["operator","param","value"],"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.0.conditions.items.[INDEX]","typeLabel":"object"},"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.0.conditions","typeLabel":"object[]"}},"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.0","typeLabel":"ToolMessageStart · object"},{"type":"object","title":"ToolMessageComplete","required":["type"],"properties":{"type":{"type":"string","description":"This message is triggered when the tool call is complete.\n\nThis message is triggered immediately without waiting for your server to respond for async tool calls.\n\nIf this message is not provided, the model will be requested to respond.\n\nIf this message is provided, only this message will be spoken and the model will not be requested to come up with a response. It's an exclusive OR.","enum":["request-complete"],"isRequired":true,"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.1.type","typeLabel":"enum\u003cstring>"},"contents":{"type":"array","description":"This is an alternative to the `content` property. It allows to specify variants of the same content, one per language.\n\nUsage:\n- If your assistants are multilingual, you can provide content for each language.\n- If you don't provide content for a language, the first item in the array will be automatically translated to the active language at that moment.\n\nThis will override the `content` property.","items":{"type":"object","title":"Text","required":["type","text","language"],"properties":{"type":{"type":"string","enum":["text"],"isRequired":true,"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.1.contents.items.[INDEX].type","typeLabel":"enum\u003cstring>"},"text":{"type":"string","isRequired":true,"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.1.contents.items.[INDEX].text","typeLabel":"string"},"language":{"type":"string","enum":["aa","ab","ae","af","ak","am","an","ar","as","av","ay","az","ba","be","bg","bh","bi","bm","bn","bo","br","bs","ca","ce","ch","co","cr","cs","cu","cv","cy","da","de","dv","dz","ee","el","en","eo","es","et","eu","fa","ff","fi","fj","fo","fr","fy","ga","gd","gl","gn","gu","gv","ha","he","hi","ho","hr","ht","hu","hy","hz","ia","id","ie","ig","ii","ik","io","is","it","iu","ja","jv","ka","kg","ki","kj","kk","kl","km","kn","ko","kr","ks","ku","kv","kw","ky","la","lb","lg","li","ln","lo","lt","lu","lv","mg","mh","mi","mk","ml","mn","mr","ms","mt","my","na","nb","nd","ne","ng","nl","nn","no","nr","nv","ny","oc","oj","om","or","os","pa","pi","pl","ps","pt","qu","rm","rn","ro","ru","rw","sa","sc","sd","se","sg","si","sk","sl","sm","sn","so","sq","sr","ss","st","su","sv","sw","ta","te","tg","th","ti","tk","tl","tn","to","tr","ts","tt","tw","ty","ug","uk","ur","uz","ve","vi","vo","wa","wo","xh","yi","yue","yo","za","zh","zu"],"isRequired":true,"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.1.contents.items.[INDEX].language","typeLabel":"enum\u003cstring>"}},"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.1.contents.items.[INDEX]","typeLabel":"Text · object"},"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.1.contents","typeLabel":"Text · object[]"},"role":{"type":"string","description":"This is optional and defaults to \"assistant\".\n\nWhen role=assistant, `content` is said out loud.\n\nWhen role=system, `content` is passed to the model in a system message. Example:\n system: default one\n assistant:\n user:\n assistant:\n user:\n assistant:\n user:\n assistant: tool called\n tool: your server response\n \u003c--- system prompt as hint\n ---> model generates response which is spoken\nThis is useful when you want to provide a hint to the model about what to say next.","enum":["assistant","system"],"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.1.role","typeLabel":"enum\u003cstring>"},"endCallAfterSpokenEnabled":{"type":"boolean","description":"This is an optional boolean that if true, the call will end after the message is spoken. Default is false.\n\nThis is ignored if `role` is set to `system`.\n\n@default false","example":false,"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.1.endCallAfterSpokenEnabled","typeLabel":"boolean"},"content":{"type":"string","description":"This is the content that the assistant says when this message is triggered.","maxLength":1000,"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.1.content","typeLabel":"string"},"conditions":{"description":"This is an optional array of conditions that the tool call arguments must meet in order for this message to be triggered.","type":"array","items":{"type":"object","properties":{"operator":{"type":"string","description":"This is the operator you want to use to compare the parameter and value.","enum":["eq","neq","gt","gte","lt","lte"],"isRequired":true,"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.1.conditions.items.[INDEX].operator","typeLabel":"enum\u003cstring>"},"param":{"type":"string","description":"This is the name of the parameter that you want to check.","maxLength":1000,"isRequired":true,"uniqueKey":"oneOf.2.messages.items.[INDEX].oneOf.1.conditions.items.[INDEX].param","typeLabel":"string"},"value":{"type":"string","description":"This is the value you want to com
[...]
